#include <stdio.h>

struct stav {
	int ptr[26];
	int zpet;
	int poc_zn;
};

struct stav stavy[20000];
int queue[20000];
int qb, qe;

int last;

void init_st(struct stav *s)
{
	memset(s, 0, sizeof(struct stav));
}

int alokuj_st()
{
	init_st(&stavy[last]);
	return last++;
}

void init_aut()
{
	init_st(&stavy[1]);
	last = 2;
}

void zarad(char *slovo)
{
	int s = 1;
	int l = strlen(slovo);
	/*printf("ZZZ: %s\n", slovo);*/
	while (*slovo) {
		int a = *slovo - 'a';
		int ns;
		if (stavy[s].ptr[a]) {
			s = stavy[s].ptr[a];
			goto c;
		}
		ns = alokuj_st();
		stavy[s].ptr[a] = ns;
		s = ns;
		c:
		slovo++;
	}
	if (l > stavy[s].poc_zn) stavy[s].poc_zn = l;
}

void zprac_frontu()
{
	int p, i;
	zac:
	if (qb >= qe) return;
	/*printf("Q:");*/
	/*for (i = qb; i < qe; i++) printf("%d ", queue[i]);*/
	/*printf("\n");*/
	p = queue[qb++];
	for (i = 0; i < 26; i++) {
		if (stavy[p].ptr[i]) {
			int pp = stavy[p].zpet;
			xxx:
			if (p == 1) stavy[stavy[p].ptr[i]].zpet = 1;
			else if (stavy[pp].ptr[i]) {
				int l;
				stavy[stavy[p].ptr[i]].zpet = stavy[pp].ptr[i];
				l = stavy[stavy[pp].ptr[i]].poc_zn;
				if (l > stavy[stavy[p].ptr[i]].poc_zn) stavy[stavy[p].ptr[i]].poc_zn = l;
			} else {
				pp = stavy[pp].zpet;
				goto xxx;
			}
			if (stavy[p].ptr[i] > 1) queue[qe++] = stavy[p].ptr[i];
		}
	}
	goto zac;
}

void nalez_zp()
{
	int i;
	stavy[1].zpet = 1;
	for (i = 0; i < 26; i++) if (!stavy[1].ptr[i]) stavy[1].ptr[i] = 1;
	qb = 0, qe = 1;
	queue[0] = 1;
	zprac_frontu();
}

char o[300][300];
int u[300][300];
int r,s;
char slovo[30];

int zarovnej(int *x, int *y)
{
	int z = 0;
	if (*x < 0 || *x >= s) *x = (*x + s) % s, z = 1;
	if (*y < 0 || *y >= r) *y = (*y + r) % r, z |= 2;
	return z;
}

void hledej_radek(int yz, int xz, int rp, int sp)
{
	int y = yz;
	int x = xz;
	int stav = 1;
	int zz = 0, count = 200;
	do {
		int c = o[y][x] - 'a';
		int ns;
		xxxx:
		ns = stavy[stav].ptr[c];
		if (!ns) {
			stav = stavy[stav].zpet;
			if (!stav) *(int *)0 = 0;
			goto xxxx;
		}
		if (stavy[ns].poc_zn) {
			int xx = x, yy = y;
			int i;
			/*printf("NALEZ: %d\n", ns);*/
			for (i = 0; i < stavy[ns].poc_zn; i++) {
				u[yy][xx] = 1;
				yy -= rp, xx -= sp;
				zarovnej(&xx, &yy);
			}
		}
		x += sp, y += rp;
		zz |= zarovnej(&x, &y);
		stav = ns;
	} while (!(zz == 3 || (zz && (rp == 0 || sp == 0))) || count--);
}

void hledej(int rp, int sp, int r1p, int s1p)
{
	int x = 0, y = 0;
	int xx, yy;
	if (rp == -1) y = r - 1;
	if (sp == -1) x = s - 1;
	xx = x, yy = y;
	do {
		hledej_radek(y, x, rp, sp);
		y += r1p;
		x += s1p;
		zarovnej(&x, &y);
	} while (x != xx || y != yy);
}

int main()
{
	int z;
	scanf("%d\n", &z);
	while (z--) {
		int i, j, sl;
		scanf("%d%d\n", &r, &s);
		if (s == 0 || r == 0) goto e;
		for(j=0; j<r; j++) {
			gets(o[j]);
		}
		for (i = 0; i < r; i++) for (j = 0; j < s; j++) u[r][s] = 0;
		memset(u, 0, sizeof(u));
		scanf("%d\n", &sl);
		init_aut();
		for (i = 0; i < sl; i++) {
			gets(slovo);
			zarad(slovo);
		}
		nalez_zp();
		for (i = 1; i < last; i++) {
			/*printf("Stav %d\n", i);*/
			/*for (j = 0; j < 26; j++) if (stavy[i].ptr[j]) printf("%c:%d ", (char)(j+'a'), stavy[i].ptr[j]);*/
			/*printf("Zpet: %d, Vysl: %d\n-------------\n", stavy[i].zpet, stavy[i].poc_zn);*/
		}
		hledej(0, 1, 1, 0);
		hledej(1, 1, 1, 0);
		hledej(1, 0, 0, 1);
		hledej(1, -1, 0, 1);
		hledej(0, -1, 1, 0);
		hledej(-1, -1, -1, 0);
		hledej(-1, 0, 0, 1);
		hledej(-1, 1, 0, 1);
		/*for (i = 0; i < r; i++) {*/
			/*for (j = 0; j < s; j++)*/
				/*if (!u[i][j]) printf("%c", o[i][j]);*/
				/*else printf(".");*/
			/*printf("\n");*/
		/*}*/
		for (i = 0; i < r; i++) for (j = 0; j < s; j++)
			if (!u[i][j]) printf("%c", o[i][j]);
		e:
		printf("\n");
	}
	return 0;
}
